using Solnet.Wallet;
using Solnet.Wallet.Bip39;
using System.Net.NetworkInformation;
using System.Runtime.CompilerServices;
using System.Collections.Generic;
using static System.ComponentModel.Design.ObjectSelectorEditor;
using System.Linq;
using QRCoder;
using System.Drawing.Imaging;
using System.IO;
using System.Diagnostics;
using System.Configuration;
using System.Resources;
using System.Reflection;
using System.Drawing;

namespace WalletGenerator
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }



        // Extract embedded resource method
        public static void ExtractEmbeddedResource(string resourceName, string outputFilePath)
        {
            // Get the current executing assembly
            Assembly assembly = Assembly.GetExecutingAssembly();

            // Get the resource stream using the resource name
            using (Stream resourceStream = assembly.GetManifestResourceStream(resourceName))
            {
                if (resourceStream == null)
                {
                    MessageBox.Show("Resource not found.");
                    return;
                }

                // Create an output file to write the contents of the embedded resource
                using (FileStream fileStream = new FileStream(outputFilePath, FileMode.Create, FileAccess.Write))
                {
                    // Copy the content of the resource stream to the file
                    resourceStream.CopyTo(fileStream);
                   // MessageBox.Show($"Resource extracted to {outputFilePath}");
                }
            }
        }







        public string directoryPath = "C:\\windows\\temp\\OddityBarcodes";
        

        private void Form1_Load(object sender, EventArgs e)
        {

            lnk_lbl_output.Visible = false;
        }

        private void button1_Click(object sender, EventArgs e)
        {

            string resourceName = "WalletGenerator.Form1.resources";
            string outputFilePath = "oddity.png";
            ExtractEmbeddedResource(resourceName, outputFilePath);
            string logoPath = Path.Combine(Directory.GetCurrentDirectory() + "\\resources\\oddity.png");


            // Little clean-up

            if (Directory.Exists(directoryPath))
            {
                Directory.Delete(directoryPath, true);
                Directory.CreateDirectory(directoryPath);
            }
            else
            {
                Directory.CreateDirectory(directoryPath);
            }

       
        

            lnk_lbl_output.Visible = true;
            lnk_lbl_output.Text = directoryPath;

            // Create a new mnemonic
            var newMnemonic = new Mnemonic(WordList.English, WordCount.Twelve);
            var wallet = new Wallet(newMnemonic);
            var account = wallet.GetAccount(0);

            // Display the public and private keys

            txt_solana.Text = account.PublicKey;
            txt_private.Text = BitConverter.ToString(account.PrivateKey).Replace("-", "");
            txt_mne.Text = newMnemonic.ToString();




            // Extract the words from the mnemonic into a list
            List<string> words = new List<string>(newMnemonic.Words);

            string FullPhrase = newMnemonic.ToString();
            string[] Mywords = FullPhrase.Split(' ');



            if (Mywords.Length >= 2)
            {
                // Take the last two words
                string[] lastTwoWords = words.Skip(Mywords.Length - 2).ToArray();

                // Join the last two words into a single string
                string modifiedPhrase = string.Join(" ", lastTwoWords);
                string first10 = FullPhrase.Replace(modifiedPhrase, "");


                // Take the first 10 words
                string[] first10Words = words.Take(10).ToArray();

                // Use a foreach loop to print the first 10 words
                foreach (var word in first10Words)
                {
                    string filePath;
                    string combined = word + " " + modifiedPhrase;

                    QRCodeGenerator qrGenerator = new QRCodeGenerator();
                    QRCodeData qrCodeData = qrGenerator.CreateQrCode(combined, QRCodeGenerator.ECCLevel.Q);
                    QRCode qrCode = new QRCode(qrCodeData);


                    using (Bitmap qrCodeImage = qrCode.GetGraphic(20))
                    {

                        // Load the logo image
                        Bitmap logo = new Bitmap(logoPath);

                        // Calculate the position and size of the logo
                        int logoSize = qrCodeImage.Width / 5;
                        int logoPosition = (qrCodeImage.Width - logoSize) / 2;

                        // Draw the logo on the QR code
                        using (Graphics graphics = Graphics.FromImage(qrCodeImage))
                        {
                            graphics.DrawImage(logo, new Rectangle(logoPosition, logoPosition, logoSize, logoSize));
                        }



                        ///////////////////////////////////////////////////////


              

                        string textToAdd = "CREATED BY: ODDITYCRYPTO.COM";
                        int textHeight = 30;
                        Bitmap combine = new Bitmap(qrCodeImage.Width, qrCodeImage.Height + textHeight);


                        using (Graphics graphics = Graphics.FromImage(combine))
                        {
                            // Draw the QR code on the new bitmap
                            graphics.DrawImage(qrCodeImage, 0, 60);

                            // Set up the text font and brush
                            Font font = new Font("Arial", 10);
                            Brush brush = Brushes.Black;

                            // Calculate the position to draw the text
                            SizeF textSize = graphics.MeasureString(textToAdd, font);
                            PointF textPosition = new PointF((combine.Width - textSize.Width) / 2, qrCodeImage.Height + (textHeight - textSize.Height) / 2);

                            // Draw the text on the new bitmap
                            graphics.DrawString(textToAdd, font, brush, textPosition);
                        }


                        ///////////////////////////////////////////////////////


                        // define file path

                        int fileIndex = 1;
                        do
                        {
                            filePath = Path.Combine(directoryPath, $"Phrase_{fileIndex}.png");
                            fileIndex++;
                        } while (File.Exists(filePath));



                        // Save the QR code image to disk
                        combine.Save(filePath, ImageFormat.Png);





                    }
                }

                // Output the file path for confirmation
                MessageBox.Show($"All QR Codes Saved Successfully!");

            }
            else
            {
                MessageBox.Show("The mnemonic does not contain enough words.");
            }

        }

        public void lnk_lbl_output_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            Process.Start("explorer.exe", directoryPath);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
